buttons = {}
require "flux"

function buttons.create(bType)
	if bType == "Play" then
		button = {}
		button.x = 270
		button.y = 300
		button.width = 245
		button.height = 80
		button.bType = bType
		button.collide = false
		table.insert(buttons,button)
	end

	if bType == "Options" then
		button = {}
		button.x = 200
		button.width = 400
		button.y = 442
		button.height = 80
		button.bType = bType
		button.collide = false
		table.insert(buttons,button)
	end

	if bType == "Volume" then
		count = 308
		level = 0
		for i = 0, 9 do
			button = {}
			button.level = level
			button.x = count
			button.y = 409
			button.width = 17
			button.height = 11
			button.a = 50
			button.bType = "Volume"
			level = level + .1
			count = count + 18
			table.insert(buttons,button)
		end
	end
	
end

function buttons.move(dt)
	for i,v in ipairs(buttons) do
		if v.bType == "Play" then
			if v.collide == true then
				flux.to(buttons[i], 1,{width = 800,x = 0})
				flux.update(dt)
			else
				flux.to(buttons[i], 1,{width = 245,x = 270})
				flux.update(dt)
			end
		end
		if v.bType == "Options" then
			if v.collide == true then
				flux.to(buttons[i], 1,{width = 800,x = 0})
				flux.update(dt)
			else
				flux.to(buttons[i], 1,{width = 400,x = 200})
				flux.update(dt)
			end
		end
	end
end

function buttons.CollisionCheck()
	for i,v in ipairs(buttons) do
		if
			love.mouse.getX() > v.x and love.mouse.getX() < v.x + v.width
			and
			love.mouse.getY() > v.y and love.mouse.getY() < v.y + v.height
		then
			--print('Mouse inside: '..v.bType)
			v.collide = true
		else
			v.collide = false
		end
	end
end


function buttons.draw()
	for i,v in ipairs(buttons)do
		if gamestate == "Paused" and v.bType == "Volume" then
			r,g,b,a = love.graphics.getColor()
			love.graphics.setColor(0,0,0,v.a)
			love.graphics.rectangle("fill", v.x, v.y, v.width, v.height)
			love.graphics.setColor(r,g,b,a)
		end
		if gamestate == "Title" then
			if v.bType == "Options" or v.bType == "Play" then
				love.graphics.rectangle("fill", v.x, v.y, v.width, v.height)
			end
		end
	end
end


function drawButtons()
	buttons.draw()
end

function updateButtons(dt)
	buttons.CollisionCheck()
	buttons.move(dt)
end