powerups = {}
local spawned = false
local effectTime = 0
local sTimer = 0
local sTimeLimit = love.math.random(30,60)
local effect = nil
local pTypes = {"SlowMotion"}

function powerups.spawn(pType)
	if pType == "Health" then
		power = {}
		power.timeLeft = 5
		power.type = pType
		power.width = 30
		power.height = 30
		power.x = love.math.random(power.width,love.graphics.getWidth()-power.width)
		power.y = love.math.random(power.height,love.graphics.getHeight()-power.height)
		power.pic = love.graphics.newImage("Pictures/Health.png")
		power.sound = love.audio.newSource("Audio/PowerUp.wav")
		table.insert(powerups,power)
	end
	if pType == "SlowMotion" then
		power = {}
		power.timeLeft = 5
		power.type = pType
		power.width = 30
		power.height = 30
		power.x = love.math.random(power.width,love.graphics.getWidth()-power.width)
		power.y = love.math.random(power.height,love.graphics.getHeight()-power.height)
		power.pic = love.graphics.newImage("Pictures/SlowMotion.png")
		power.sound = love.audio.newSource("Audio/SlowMotion.wav")
		table.insert(powerups,power)
	end
end



function powerups.detectHit()
	for i,v in ipairs(powerups) do
		if player.y < v.y + v.height and player.y + player.height > v.y and player.x < v.x + v.width and player.x + player.width > v.x
			or
			player.x < v.x + v.width and player.x + player.width > v.x and player.y < v.y + v.height and player.y + player.height > v.y
		then
			if v.type == "Health" then
				table.remove(powerups,i)
				love.audio.play(v.sound)
				local newHealth = love.math.random(20,30)
				damage.spawn(newHealth,"Health")
				print(newHealth)
				if player.health + newHealth > 117 then
					player.health = 117
				else
					player.health = player.health + newHealth
				end
			end
			if v.type == "SlowMotion" then
				table.remove(powerups,i)
				love.audio.play(v.sound)
				effect = "SlowMotion"
			end
		end
	end
end

function powerups.effect(dt)
	if effect == "SlowMotion" then
		if effectTime < 5 then
			effectTime = effectTime + 1 * dt
			for i,v in ipairs(enemies) do
				v.speed = .5
			end
		else
			for i,v in ipairs(enemies) do
				v.speed = v.oSpeed
			end
			effectTime = 0
			effect = nil
		end
	end
end

function powerups.update(dt)
	for i,v in ipairs(powerups) do
		if v.timeLeft <= 0 then
			table.remove(powerups,i)
		end
		v.timeLeft = v.timeLeft - 1 * dt
	end
end	

function powerups.spawnHandler(dt)
	if sTimer > sTimeLimit then
		chosen = pTypes[math.random(1,#pTypes)]
		powerups.spawn(chosen)
		sTimer = 0
		sTimeLimit = math.random(60,120)
	end
	sTimer = sTimer + 1 * dt
end


function powerups.draw()
	for i,v in ipairs(powerups) do
		love.graphics.draw(v.pic,v.x,v.y)
	end	
end


function updatePowerUps(dt)
	powerups.detectHit()
	powerups.update(dt)
	powerups.spawnHandler(dt)
	powerups.effect(dt)
end

function drawPowerUps()
	powerups.draw()
end